!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine MassCondense
!
!   * Developer: KITAMORI Taichi, YAMASHITA Tatsuya
!   * Version: $ 
!   * Tag Name: $Name: arare4-20120911 $
!   * Change History: 
!
!== Overview 
!
!ŷ/ȯ̤׻.
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
! ȻˤäƱγĹˤĹ. 
! ȯ̤¸ߤ̤¿, ȯ̤¸ߤ̤ˤ. 
! ̩٤ȯŸ(ŷʬ)׻. 
! ˾ʤäȤ˾ȯʤʤäƤޤäƤΤ,
! ʬľ.

!
!== Future Plans
!
                                                                 !=end
subroutine MassCondense(  &
  & DelTimeShort,              &  !(in) ֳִ
  & xz_SatRatioNs, &         !(in) ˰
  & xz_PotTempNs,     &      !(in) 
  & xz_ExnerNs,       &      !(in) ʡؿ
  & xz_DensCloudAs,     &    !(inout) ̩
  & xz_MassCondNs)           !(out) ŷ
                                                                 !=begin
  !==Dependency
  use dc_trace, only: BeginSub, EndSub, DbgMessage
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
  use cloudset, only: DensIce, &        ! ʪ̩ 
    &                 NumAerosol, &     ! ̤ζŷ˿̩
    &                 RadiAerosol, &    ! ŷȾ
    &                 Kd,     &         ! 絤γȻ
    &                 SatRatioCr        ! ׳˰
  use basicset, only: xz_PotTempBasicZ,  & ! ̴ܾ
    &                 xz_ExnerBasicZ,  &   ! ̵
    &                 xz_DensBasicZ,   &   ! ̩
    &                 GasRDry,         &   ! 
    &                 PressSfc,        &   ! ɽ̰
    &                 CpDry,           &   ! 갵Ǯ
    &                 LatHeatPerMass       ! CO2 ñ̼̤Ǯ
  use StoreDensCloud, only: StoreDensCloudCond

                                                                 !=end
  !==ۤηػ
  implicit none
  
  !==Input
  real(8), intent(in)  :: DelTimeShort       ! ֥ƥå [s]
  real(8), intent(in)   :: xz_SatRatioNs(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ˰ [1]
  real(8), intent(in)   :: xz_PotTempNs(DimXMin:DimXMax, DimZMin:DimZMax) 
                                        !  [K]
  real(8), intent(in)   :: xz_ExnerNs(DimXMin:DimXMax, DimZMin:DimZMax) 
                                        ! ̵ [1]
  real(8), intent(inout) :: xz_DensCloudAs(DimXMin:DimXMax, DimZMin:DimZMax)   
                                        ! ̩   [kg/m^3]


  !==Output
  real(8), intent(out)  :: xz_MassCondNs(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ŷ [kg/m^3 s]
   
  !==Work
  real(8)               :: xz_Rh(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ǮȻˤ񹳷
  real(8)               :: xz_RadiCloud(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γȾ [m]
  real, parameter       :: Pi = 3.1415926535897932385d0
                                        ! ߼Ψ
!  real(8)               :: DensCloudThreshold = 1.0d-5
!  real(8)               :: DensCloudThreshold = 5.0d-6
  real(8)               :: DensCloudThreshold = 5.0d-5
  integer               :: i,k          ! 롼ѿ

  call BeginSub("MassCondense", &
    &           fmt="%c",        &
    &           c1="Calculate latent heat per unit mass.")

  
  call DbgMessage( fmt="*** Debug Message [MassCondense] *** xz_Rh ")

!write(*,*) xz_PotTempNs(1,:)

  xz_Rh =  & 
    & LatHeatPerMass ** 2.0d0 &
    & / (  &
    &      Kd * GasRDry * (xz_ExnerBasicZ + xz_ExnerNs)** 2.0d0 &
    &      * (xz_PotTempBasicZ + xz_PotTempNs)**2.0d0  &
    &   )
      ! , 20080410, 
      ! L**2 / (k * R * Exner**2 * theta**2) Ȥͤ׻Ƥ. 
      ! ʸ : ̼齤Ͽ A ƳвҤƤ. 
      ! â, ̼齤ʸ Rh μ (3.4) ˤϸΤդ줿. 
      ! ʽȤ 1 ȸϤɤʤΤĴ٤ɬפꤽ. 

  call DbgMessage( fmt="*** Debug Message [MassCondense] *** xz_RadiCloud ")


  xz_RadiCloud =   &
    & (  &
    &      3.0d0 * xz_DensCloudAs &
    &      / (4.0d0 * Pi * DensIce * NumAerosol * xz_DensBasicZ) & 
    &      + RadiAerosol**3.0d0  &
    &   )**(1.0d0 / 3.0d0)

do k= DimZMin, DimZMax
   do i = DimXMin, DimXMax

      if (xz_SatRatioNs(i,k) - SatRatioCr > epsilon(0.0d0)) then
! ˰椬᤿׳˰礭
! CO2 ˰μϵ絤Ѥ˰μʤΤʤΤǧɬפ. 

        xz_MassCondNs(i,k) = &
          & max( - xz_DensCloudAs(i,k) / DelTimeShort, &
          & 4.0d0 * Pi * xz_RadiCloud(i,k) &
          & * NumAerosol * xz_DensBasicZ(i,k)  &
          & / xz_Rh(i,k)  &
          & * (xz_SatRatioNs(i,k) - 1.0d0) )

     else if (xz_DensCloudAs(i,k) > DensCloudThreshold ) then
! ׳˰ĶƤʤ, ̩٤ͰʾǤ
! ˰椬 1 ʾΤȤ˶ŷ, 1 ʲΤȤ˾ȯ. 
        xz_MassCondNs(i,k) = &
          & max( - xz_DensCloudAs(i,k) / DelTimeShort, &
          &   4.0d0 * Pi * xz_RadiCloud(i,k) &
          & * NumAerosol * xz_DensBasicZ(i,k)  &
          & / xz_Rh(i,k)  &
          & * (xz_SatRatioNs(i,k) - 1.0d0) )

     else if (xz_DensCloudAs(i,k) /= 0.0d0 .and. xz_SatRatioNs(i,k) < 1.0d0 ) then
! ̩٤̤, ˰ 1.0 ̤Ǥ˾ȯ. 
        xz_MassCondNs(i,k) = &
          & max( - xz_DensCloudAs(i,k) / DelTimeShort, &
          &   4.0d0 * Pi * xz_RadiCloud(i,k) &
          & * NumAerosol * xz_DensBasicZ(i,k)  &
          & / xz_Rh(i,k)  &
          & * (xz_SatRatioNs(i,k) - 1.0d0) )

     else
! ʳξϲʤ. 

        xz_MassCondNs(i,k) = 0.0d0

     end if

!     call StoreDensCloudCond( xz_MassCondNs(i,k) )

     xz_DensCloudAs(i,k) = &
          & xz_DensCloudAs(i,k) + DelTimeShort * xz_MassCondNs(i,k)

  end do
end do

     call StoreDensCloudCond( xz_MassCondNs )

  call EndSub("MassCondense")

end subroutine MassCondense
